/**
 * Copyright (c) 2020 xxx Inc.
 * File              : image-preprocess.h
 * Author            : 
 * Date              : 2020-05-07
 * Last Modified Date: 2020-05-07
 * Last Modified By  : 
 */
#include "vf/dl/preprocess.h"

namespace vf {
namespace dl {

struct ScaleMeanStdHWCKernel {
  XINLINE static void Map(int img_id, int pid, int C, int HW, const float* src,
                          float* dst, float scale, const float* mean,
                          const float* std) {
    int offset = img_id * HW * C + pid * C;
    src = src + offset;
    dst = dst + offset;
    for (int c = 0; c < C; ++c) {
      dst[c] = (scale * src[c] - mean[c]) / std[c];
    }
  }
};

struct ScaleMeanStdCHWKernel {
  XINLINE static void Map(int img_id, int pid, int C, int HW, const float* src,
                          float* dst, float scale, const float* mean,
                          const float* std) {
    int offset = img_id * HW * C + pid;
    src = src + offset;
    dst = dst + offset;
    for (int c = 0; c < C; ++c, src += HW, dst += HW) {
      *dst = (*src * scale - mean[c]) / std[c];
    }
  }
};

}  // namespace dl
}  // namespace vf
